import { Component, AfterViewInit } from "@angular/core";

/*
  tient lieu d'import quand on n'installe pas de paquet npm pour MathJax et qu'on le récupère
  par l'index.html :
   <script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.0/MathJax.js?config=TeX-AMS_CHTML"></script>
*/
declare var MathJax: any;

import { FormulaireDefinition } from "../../formulaire/definition/form-definition";

@Component({
    selector: 'help',
    templateUrl: "./help.component.html",
})
export class HelpComponent implements AfterViewInit {
    /**
     * texte de l'aide
     */
    private textData: string;

    /**
     * fixe le texte de l'aide d'après un formulaire
     */
    public set formHelp(f: FormulaireDefinition) {
        this.textData = f.helpText;
    }

    /**
     * MAJ des expressions LateX présentes dans le composant par MathJax
     */
    private updateMathjax() {
        //     MathJax.Hub.Queue(["Typeset", MathJax.Hub]);
        MathJax.Hub.Typeset();
    }

    public ngAfterViewInit() {
        this.updateMathjax();
    }
}
