import { Component, Input, Output, EventEmitter } from "@angular/core";

import { SelectField, } from "../../formulaire/select-field";
import { SelectEntry } from "../../formulaire/select-entry";
import { GenericSelectComponent } from "../generic-select/generic-select.component";

@Component({
    selector: "select-field-line",
    templateUrl: "./select-field-line.component.html"
})
export class SelectFieldLineComponent extends GenericSelectComponent<SelectEntry> {
    @Input("param")
    private _select: SelectField;

    protected get entries(): SelectEntry[] {
        if (this._select == undefined)
            return [];
        return this._select.entries;
    }

    protected entryLabel(entry: SelectEntry): string {
        return entry.label;
    }

    public get selectedValue(): SelectEntry {
        return this._select.getValue();
    }

    public set selectedValue(v: SelectEntry) {
        this._select.setValue(v);
    }
}
