import { Component, NgModule, ErrorHandler, Injectable } from '@angular/core';

import { ErrorService } from './services/error/error.service';

@Component({
    selector: 'app-error-handler',
    template: `<span style="color:red">{{errorText}}</span>`
})
export class AppErrorHandler extends ErrorHandler {
    constructor(private errorService: ErrorService) {
        super();
    }

    handleError(error: any) {
        // console.log("COUCOU AppErrorHandler.handleError " + error);
        this.errorService.doAlert(error);
    }

    call(error: any, stackTrace: any = null, reason: any = null) {
        console.log("COUCOU AppErrorHandler.call");
    }
}

@NgModule({
    declarations: [AppErrorHandler],
    exports: [AppErrorHandler],
    providers: [ErrorService, { provide: ErrorHandler, useClass: AppErrorHandler }]
})
export class AppErrorModule {
    constructor(private errorService: ErrorService) {
    }
}
