import { Field } from "./field";
import { Dependency } from "./dependency/dependency";
import { DependencyConditionType } from "./dependency/dependency-condition";
import { FormulaireDefinition } from "./definition/form-definition";
import { FormulaireNode } from "./formulaire-node";

export class CheckField extends Field {
    private _value: boolean;

    constructor(parent: FormulaireNode) {
        super(parent);
        this._value = false;
    }

    public getValue(): boolean {
        return this._value;
    }

    public setValue(val: boolean) {
        this._value = val;
    }

    public get isValid(): boolean {
        return true;
    }

    public parseConfig(json: {}, data?: {}) {
        this._confId = json["id"];
        this.setValue(json["value"] == "true");
    }
}
