import { FieldSet } from "./fieldset";
import { CalculatorType, ComputeNodeType } from "jalhyd";
import { FormulaireDefinition } from "./definition/form-definition";
import { FieldsetContainer } from "./fieldset-container";

export class FieldsetTemplate {
    private _jsonConfig: {};

    constructor(config: {}) {
        this._jsonConfig = config;
    }

    public get config() {
        return this._jsonConfig;
    }

    public get calcTypeFromConfig(): CalculatorType {
        for (const k in this._jsonConfig) {
            if (k === "calcType") {
                const ct: string = this._jsonConfig[k];
                var calcType: CalculatorType = CalculatorType[ct];
                break;
            }
        }

        return calcType;
    }

    public get defaultNodeTypeFromConfig(): ComputeNodeType {
        for (const k in this._jsonConfig) {
            if (k === "defaultNodeType") {
                const nt: string = this._jsonConfig[k];
                var nodeType: ComputeNodeType = ComputeNodeType[nt];
                break;
            }
        }

        return nodeType;
    }

    /**
     * crée une instance de Fieldset et l'ajoute dans un conteneur
     * @param cont conteneur
     * @param at position à laquelle on ajoute le nouveau FieldSet
     */
    public instantiateTemplate(cont: FieldsetContainer, after: number): FieldSet {
        const parentForm = cont.parent as FormulaireDefinition;
        const res = parentForm.createFieldset(cont, this._jsonConfig, { "template": this, "after": after });
        res.parseConfig(this._jsonConfig);
        parentForm.afterParseFieldset(res);
        return res;
    }
}
