import { Injectable } from "@angular/core";
import { Response } from "@angular/http";

import { CalculatorType } from "jalhyd";
import { Language } from "../internationalisation/internationalisation.service";
import { ServiceFactory } from "../service-factory";
import { FormulaireDefinition } from "../../formulaire/definition/form-definition";

@Injectable()
export class HelpService {
    /**
     * charge l'aide en ligne d'un formulaire
     * @param form formulaire dont on veut l'aide
     * @param lang langue souhaitée
     */
    public loadFormHelp(form: FormulaireDefinition, lang: Language): Promise<Response> {
        const processData = function (s: string) {
            form.helpText = s;
        }
        const processError = function (err: any) {
            form.helpText = undefined;
        }

        const prefix = ServiceFactory.instance.formulaireService.getConfigPathPrefix(form.calculatorType);
        const helpFile: string = `${prefix}${lang.tag}.md`;
        // const headers = { "Content-Type": "application/octet-stream" };
        // return ServiceFactory.instance.httpService.httpGetRequest(undefined, undefined, undefined, helpFile, processData, processError, headers);
        return ServiceFactory.instance.httpService.httpGetRequest(undefined, undefined, undefined, helpFile, processData, processError);
    }
}
